routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();
Route::get('/', function () {
    return view('auth.login');
})->name('');
Route::group(['middleware' => 'auth'], function () {
    Route::get('/home', 'HomeController@index')->name('home');
    Route::resource('devices', 'DevicesController');
    Route::post('/devices/{device}', 'DevicesController@delete')->name('devices.delete');
    Route::get('/search', 'DevicesController@search')->name('devices.search');
    Route::put('/bulk-active', 'DevicesController@bulkActive')->name('devices.bulk-active');
    Route::put('/bulk-deactive', 'DevicesController@bulkDeactive')->name('devices.bulk-deactive');
    Route::put('/bulk-delete', 'DevicesController@bulkDelete')->name('devices.bulk-delete');
});

app/Models/Device.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Device extends Model
{

    protected $fillable = [
        'employee_id',
        'imei',
        'platform',
        'token',
        'is_actived'
    ];
}

app/Http/Controllers/DevicesController.php
<?php

namespace App\Http\Controllers;

use App\Device;
use App\Enums\Mode;
use App\Enums\Status;
use App\Http\Requests\DeviceCreateRequest;
use App\Http\Requests\DeviceUpdateRequest;
use App\Http\Services\DevicesService;
use Illuminate\Contracts\View\Factory;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Routing\Redirector;
use Illuminate\Support\Facades\Auth;
use Illuminate\View\View;
use PHPUnit\Exception;

class DevicesController extends Controller
{
    protected $devicesService;

    protected $STATUS_SUCCESS = 'success';
    protected $STATUS_FAIL = 'fail';

    protected $ROUTE_INDEX = 'devices.index';
    protected $ROUTE_CREATE = 'devices.create';

    protected $ATTR_DEVICE = 'device';
    protected $ATTR_MODE = 'mode';

    public function __construct(DevicesService $devicesService)
    {
        $this->devicesService = $devicesService;
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Factory|View
     */
    public function create()
    {
        $responseData = [
            $this->ATTR_DEVICE => null,
            $this->ATTR_MODE => Mode::CREATE
        ];

        return view($this->ROUTE_CREATE)->with($responseData);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param DeviceCreateRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(DeviceCreateRequest $request)
    {
        $device = Device::create([
            'imei' => $request->imei,
            'token' => $request->token,
            'platform' => $request->platform,
            'is_actived' => $request->is_actived == null ? 0 : 1,
            'employee_id' => Auth::user()->id
        ]);
        try {
            $this->devicesService->store($device);
            session()->flash($this->STATUS_SUCCESS, 'Device created successful!');
        } catch (Exception $e) {
            session()->flash($this->STATUS_FAIL, 'Fail to create device. Error: ' . $e);
        }
        return redirect(route($this->ROUTE_INDEX));
    }

    /**
     * Display the specified resource.
     *
     * @param Device $device
     * @return Factory|View
     */
    public function show(Device $device)
    {
        $responseData = [
            $this->ATTR_DEVICE => $device,
            $this->ATTR_MODE => Mode::VIEW
        ];
        return view($this->ROUTE_CREATE)->with($responseData);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Device $device
     * @return Factory|View
     */
    public function edit(Device $device)
    {
        if ($device->is_deleted == 1) {
            session()->flash($this->STATUS_FAIL, 'Cannot edit deleted device!');
            return redirect(route($this->ROUTE_INDEX));
        }

        $responseData = [
            $this->ATTR_DEVICE => $device,
            $this->ATTR_MODE => Mode::EDIT
        ];
        return view($this->ROUTE_CREATE)->with($responseData);
    }

    /**
     * Display a listing of the resource.
     *
     * @return Response
     */
    public function index()
    {
        $search_param = [
            'imei' => '',
            'platform' => '',
            'status' => Status::getKey(Status::ALL)
        ];

        return view($this->ROUTE_INDEX)->with([
                'devices' => $this->devicesService->getAll(),
                'search_param' => $search_param]
        );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param DeviceUpdateRequest $request
     * @param Device $device
     * @return RedirectResponse|Redirector
     */
    public function update(DeviceUpdateRequest $request, Device $device)
    {
        if ($device->is_deleted == 1) {
            session()->flash($this->STATUS_FAIL, 'Cannot update deleted device!');
            return redirect(route($this->ROUTE_INDEX));
        }

        try {
            $device->imei = $request->imei;
            $device->platform = $request->platform;
            $device->token = $request->token;
            $device->is_actived = $request->is_actived == null ? 0 : 1;
            $device->employee_id = Auth::user()->id;

            $this->devicesService->store($device);
            session()->flash($this->STATUS_SUCCESS, 'Device updated successful!');
        } catch (Exception $e) {
            session()->flash($this->STATUS_FAIL, 'Fail to update device. Error: ' . $e);
        }
        return redirect(route($this->ROUTE_INDEX));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Device $device
     * @return RedirectResponse|Redirector
     */
    public function delete(Device $device)
    {
        if ($device->is_deleted == 1) {
            session()->flash($this->STATUS_FAIL, 'Cannot delete deleted device!');
            return redirect(route($this->ROUTE_INDEX));
        }

        try {
            $device->is_deleted = 1;
            $this->devicesService->store($device);
            session()->flash($this->STATUS_SUCCESS, 'Device deleted successful!');
        } catch (Exception $e) {
            session()->flash($this->STATUS_FAIL, 'Fail to delete device. Error: ' . $e);
        }
        return redirect(route($this->ROUTE_INDEX));
    }

    public function search(Request $request)
    {
        $search_param = [
            'imei' => $request->imei,
            'platform' => $request->platform,
            'status' => $request->status
        ];

        $result = $this->devicesService->search($search_param);
        return view($this->ROUTE_INDEX)->with([
            'devices' => $result,
            'search_param' => $search_param
        ]);
    }

    public function bulkActive(Request $request)
    {
        try {
            $this->devicesService->active($request->input('ids'));
            session()->flash($this->STATUS_SUCCESS, 'Devices active successful!');
        } catch (Exception $e) {
            session()->flash($this->STATUS_FAIL, 'Fail to active devices. Error: ' . $e);
        }
    }

    public function bulkDeactive(Request $request)
    {
        try {
            $this->devicesService->deactive($request->ids);
            session()->flash($this->STATUS_SUCCESS, 'Devices deactive successful!');
        } catch (Exception $e) {
            session()->flash($this->STATUS_FAIL, 'Fail to deactive devices. Error: ' . $e);
        }
    }

    public function bulkDelete(Request $request)
    {
        try {
            $this->devicesService->delete($request->ids);
            session()->flash($this->STATUS_SUCCESS, 'Devices delete successful!');
        } catch (Exception $e) {
            session()->flash($this->STATUS_FAIL, 'Fail to delete devices. Error: ' . $e);
        }
    }

}

resources/views/devices/create.blade.php
@extends('layouts.layout')

@section('page-title')
    <div id="page-title">

        <nav aria-label="breadcrumb">
            <ol class="breadcrumb">
                <li class="breadcrumb-item active" aria-current="page"><a class="page-header text-overflow" href="#">Device</a>
                </li>
            </ol>
        </nav>
    </div>
@endsection

@section('page-content')
    <div class="panel">
        <div class="panel-heading">
            @if( $mode === \App\Enums\Mode::VIEW)
                <h3 class="panel-title">Detail</h3>
            @elseif($mode === \App\Enums\Mode::CREATE)
                <h3 class="panel-title">Create</h3>
            @else
                <h3 class="panel-title">Update</h3>
            @endif
        </div>

        @if($errors->any())

            <div class="alert alert-danger">
                @foreach($errors->all() as $error)
                {{ $error }} </br>
                @endforeach
            </div>

        @endif

        @if(\App\Enums\Mode::CREATE == $mode)
            <form id="input-form" action="{{ route('devices.store') }}" method="POST">
                @csrf
                @include('devices.form-create')
            </form>
        @else
            <form id="input-form" action="{{ route('devices.update', $device['id']) }}" method="POST">
                @csrf
                @method('PUT')
                @include('devices.form-create')
            </form>
        @endif
    </div>
@endsection

@section('script')
    var switcheryElement;

    <script>
        $(document).ready(function () {
            initSwitchery();
            checkFormEditable({!!$mode === \App\Enums\Mode::VIEW !!});
            handleResetClick();
        });

        function initSwitchery() {
            var elem = document.querySelector('.js-switch');
            switcheryElement = new Switchery(elem);
        }

        function disableSwitchery() {
            switcheryElement.disable();
        }

        function checkFormEditable(isViewMode) {
            if (isViewMode) {
                disableSwitchery()
                var inputs = document.getElementsByTagName('input');
                for (var x = 0; x < inputs.length; x++) {
                    inputs[x].disabled = 'disabled';
                }
                var textAreas = document.getElementsByTagName('textarea');
                for (var x = 0; x < textAreas.length; x++) {
                    textAreas[x].disabled = 'disabled';
                }
            }
        };

        function handleResetClick() {
            $('#reset').on('click', function () {
                location.reload();
            });
        }
    </script>
@endsection

resources/views/devices/form-create.blade.php
<div class="panel-body">
    <div class="row">
        <div class="col-sm-6">
            <div class="form-group">
                <label class="control-label text-bold">Imei</label>
                <input name="imei" id="imei" type="text" class="form-control" value="{{ $device['imei'] }}">
            </div>
        </div>
        <div class="col-sm-6">
            <div class="form-group">
                <label class="control-label text-bold">Platform</label>
                <input name="platform" id="platform" type="text" class="form-control"
                       value="{{ $device['platform'] }}">
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-sm-6">
            <div class="form-group">
                <label class="control-label text-bold">Token</label>
                <textarea name="token" id="token" rows="4"
                          class="form-control">{{ $device['token'] }}</textarea>
            </div>
        </div>
        <div class="col-sm-6">
            <div class="form-group">
                <label class="control-label text-bold">Is active</label> <br>
                <!--Switchery : Checked-->
                <!--===================================================-->
                <input name="is_actived" id="is_actived" type="checkbox"
                       class="form-control js-switch" {{ $device['is_actived'] == 1 ? 'checked' : '' }}/>
                <!--===================================================-->
            </div>
        </div>
    </div>
</div>

<div class="panel-footer text-right">
    <a class="btn btn-warning" href="{{ route('devices.index') }}"><i
            class="glyphicon glyphicon-chevron-left"></i> Back</a>
    @if( $mode !== \App\Enums\Mode::VIEW)
        <button id="reset" type="button" class="btn btn-default"><i
                class="glyphicon glyphicon-refresh"></i> Reset
        </button>
        <button type="submit" class="btn btn-primary"><i
                class="glyphicon glyphicon-floppy-saved"></i> {{ \App\Enums\Mode::CREATE == $mode ? 'Create' : 'Save' }}
        </button>
    @endif
</div>

resources/views/devices/index.blade.php
@extends('layouts.layout')

@section('page-title')
    <div id="page-title">
        <h1 class="page-header text-overflow">Device Manager</h1>
    </div>
@endsection

@section('page-content')

    <div class="panel">
        <div class="panel-heading">
            <h3 class="panel-title">Search</h3>
        </div>
        <form action="{{ route('devices.search') }}" method="GET">
            <div class="panel-body">
                <div class="row">
                    <div class="col-sm-4">
                        <div class="form-group">
                            <label>Imei</label>
                            <input type="text" class="form-control" name="imei"
                                   value="{{ isset($search_param) ? $search_param['imei'] : '' }}">
                        </div>
                    </div>
                    <div class="col-sm-4">
                        <div class="form-group">
                            <label class="control-label">Platform</label>
                            <input type="text" class="form-control" name="platform"
                                   value="{{ isset($search_param) ? $search_param['platform'] : '' }}"/>
                        </div>
                    </div>
                    <div class="col-sm-4">
                        <div class="form-group">
                            <label class="control-label">Status</label>
                            <select class="form-control" name="status">
                                @foreach(\App\Enums\Status::getKeys() as $status)
                                    <option
                                        value="{{ $status }}" {{ \App\Enums\Status::getValue($status) == \App\Enums\Status::getValue($search_param['status']) ? 'selected' : '' }}>
                                        {{  \App\Enums\Status::getValue($status) }}
                                    </option>device
                                @endforeach
                            </select>
                        </div>
                    </div>
                </div>
                <div class="col-sm-12 text-right">
                    <a href="{{ route('devices.index') }}" class="btn btn-default"><i
                            class="glyphicon glyphicon-refresh"></i> Clear</a>
                    <button type="submit" class="btn btn-primary"><i class="glyphicon glyphicon-search"></i> Search
                    </button>
                </div>
            </div>
        </form>
    </div>

    <div class="panel">
        <div class="panel-heading">
            <h3 class="panel-title">Device List</h3>
        </div>

        <div class="panel-body">
            <div class="pad-btm form-inline">
                <div class="row">
                    <div class="col-sm-12 table-toolbar-right">
                        <button class="btn btn-primary" onclick="addDevice()"><i class="glyphicon glyphicon-plus"></i>
                            Add
                        </button>
                        <button id="bulk-active" type="button" class="btn btn-success" onclick="bulkActive()">
                            <i class="glyphicon glyphicon-ok-circle"></i> Active
                        </button>
                        <button id="buok-deactive" type="button" class="btn btn-warning" onclick="bulkDeactive()">
                            <i class="glyphicon glyphicon-ban-circle"></i>
                            Deactive
                        </button>
                        <button id="buld-delete" type="button" class="btn btn-danger" onclick="bulkDelete()">
                            <i class="glyphicon glyphicon-trash"></i> Delete
                        </button>
                    </div>
                </div>
            </div>
            <div class="table-responsive">
                <table class="table table-striped table-bordered" id="tblDevice">
                    <thead>
                    <tr>
                        <th class="text-center" id="thCheckAll">
                            <input id="checkAll" class="magic-checkbox" type="checkbox">
                            <label for="checkAll"></label>
                        </th>
                        <th>Imei</th>
                        <th>Platform</th>
                        <th>Token</th>
                        <th class="text-center">Statut</th>
                        <th></th>
                    </tr>
                    </thead>
                    <tbody>
                    @if (count($devices) > 0)
                        @foreach($devices as $device)
                            <tr>
                                <td class="text-center">
                                    <input id="{{ 'check_' . $device->id }}" class="magic-checkbox"
                                           type="checkbox" {{ $device->is_deleted ? 'disabled' : ''}}>
                                    <label for="{{ 'check_' . $device->id }}"></label>
                                    <input type="hidden" class="device_id" value="{{ $device->id }}"/>
                                </td>
                                <td>{{ $device->imei }}</td>
                                <td>{{ $device->platform }}</td>
                                <td>{{\Illuminate\Support\Str::limit($device->token, 60)}}</td>
                                <td class="text-center">
                                    @if($device->is_deleted)
                                        <div class="label label-table label-danger my-2">Deleted</div>
                                    @else
                                        <div
                                            class="label label-table  {{ $device->is_actived ? "label-success" : "label-warning"}}">
                                            {{ $device->is_actived ? 'Activated' : " In Activated " }}
                                        </div>
                                    @endif
                                </td>
                                <td class="text-center"
                                    style="max-width:100%; white-space: nowrap;">
                                    <a href="{{ route('devices.show', $device->id) }}" class="btn btn-success btn-icon">
                                        <i class="glyphicon glyphicon-eye-open"></i>
                                    </a>
                                    @if(!$device->is_deleted)
                                        <a href="{{ route('devices.edit', $device->id) }}"
                                           class="btn btn-warning btn-icon"><i class="glyphicon glyphicon-edit"></i>
                                        </a>

                                        <form action="{{ route('devices.destroy', $device->id) }}" method="POST">
                                            @csrf
                                            <button type="submit" class="btn btn-danger btn-icon mar-top"><i
                                                    class="glyphicon glyphicon-trash"></i>
                                            </button>
                                        </form>
                                    @endif
                                </td>
                            </tr>
                        @endforeach

                    @else
                        <tr>
                            No data found
                        </tr>
                    @endif
                    </tbody>
                </table>
                <div class="row">
                    <div class="form-group col-12 text-center">
                        {{ $devices->appends($search_param)->links() }}
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('script')
    <script>
        $(document).ready(function () {
            initCheckAllEvent();
        });

        function addDevice() {
            window.location = '{{ url(route('devices.create')) }}';
        }

        function bulkActive() {
            var ids = getSelectedDevices();
            if (ids.length > 0) {
                initComfirmationBox('Are you sure to active selected devices?', function () {
                    $.ajax({
                        url: "{{ route('devices.bulk-active') }}",
                        method: "PUT",
                        data: {
                            ids: ids,
                            _token: '{{csrf_token()}}'
                        },
                        success: function (data) {
                            location.reload();
                        }
                    })
                })
            } else {
                bootbox.alert("You must select at least 1 device!");
            }
        }

        function bulkDeactive() {
            var ids = getSelectedDevices();
            if (ids.length > 0) {
                initComfirmationBox('Are you sure to de-active selected devices?', function () {
                    $.ajax({
                        url: "{{ route('devices.bulk-deactive') }}",
                        method: "PUT",
                        data: {
                            ids: ids,
                            _token: '{{csrf_token()}}'
                        },
                        success: function (data) {
                            location.reload();
                        }
                    })
                })
            } else {
                bootbox.alert("You must select at least 1 device!");
            }
        }

        function bulkDelete() {
            var ids = getSelectedDevices();
            if (ids.length > 0) {
                initComfirmationBox('Are you sure to delete selected devices?', function () {
                    $.ajax({
                        url: "{{ route('devices.bulk-delete') }}",
                        method: "PUT",
                        data: {
                            ids: ids,
                            _token: '{{csrf_token()}}'
                        },
                        success: function (data) {
                            location.reload();
                        }
                    })
                })
            } else {
                bootbox.alert("You must select at least 1 device!");
            }
        }


        function getSelectedDevices() {
            return $("#tblDevice tbody").find("input[type=checkbox]:checked").map(function () {
                return $(this).siblings('input.device_id').val();
            }).get().filter(function (v) {
                return v !== ''
            });
        }

        function initCheckAllEvent() {
            $('#checkAll').click(function () {
                var isCheckAllChecked = $(this).prop("checked");
                var rows = $('#tblDevice tr:has(td)').find('input[type="checkbox"]');
                for (var x = 0; x < rows.length; x++) {
                    if (!$(rows[x]).is(':disabled')) {
                        $(rows[x]).prop('checked', isCheckAllChecked);
                    }
                }
            });
        }

        function initComfirmationBox(message, callback) {
            bootbox.confirm(message, function (result) {
                if (result) {
                    callback()
                } else {
                    $.niftyNoty({
                        type: 'danger',
                        icon: 'pli-cross icon-2x',
                        message: 'Cancelled',
                        container: 'floating',
                        timer: 3000
                    });
                }
                ;

            });
        }
    </script>
@endsection